P10111 [GESP202312 七级] 纸牌游戏 题解

Leo2011 大气压强

看标签知道要用 DP。

于是开始分析。

状态: 轮中,第 轮出 ,一共换了 次牌的最大钱数。很好理解。

转移也不难,不就是不换和换两种吗!

所以,转移就是: 其中, 表示你要换的牌,显然要求 表示你出牌 ,小杨出 时的胜负情况。胜返回 ,负返回 ,平返回 。上面就是不还,下面就是换。

观察发现,获胜时要么大 ,要么小 (因为此处 “”)。

所以 函数如下:

1
2
3
4
5
int pk(int x, int y) {
if (x == y) return 1;
if (x == y + 1 || x == y - 2) return 2;
return 0;
}

以上为朴素做法。还能不能优化呢?滚动数组嘛!这玩意儿不就是专门给其中一维是 “前 回……” 的 DP 状态砍掉这维的嘛!

于是用上滚动数组(这个不会的去看背包),空间复杂度就可以降到 啦!


用上滚动数组的:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
// Problem: P10111 [GESP202312 七级] 纸牌游戏
// Contest: Luogu
// URL: https://www.luogu.com.cn/problem/P10111
// Memory Limit: 512 MB
// Time Limit: 1000 ms
//
// Powered by CP Editor (https://cpeditor.org)

/*Code by Leo2011*/
#include <bits/stdc++.h>

#define log printf
#define EPS 1e-8
#define INF 0x3f3f3f3f
#define FOR(i, l, r) for (int(i) = (l); (i) <= (r); ++(i))
#define IOS \
ios::sync_with_stdio(false); \
cin.tie(nullptr); \
cout.tie(nullptr);

using namespace std;

typedef __int128 i128;
typedef long long ll;
typedef pair<int, int> PII;

const int N = 1010;
int n, a[N], b[N], c[N], dp[3][N], ans = -INF;

template <typename T>

inline T read() {
T sum = 0, fl = 1;
char ch = getchar();
for (; !isdigit(ch); ch = getchar())
if (ch == '-') fl = -1;
for (; isdigit(ch); ch = getchar()) sum = sum * 10 + ch - '0';
return sum * fl;
}

template <typename T>

inline void write(T x) {
if (x < 0) putchar('-'), write<T>(-x);
static T sta[35];
int top = 0;
do { sta[top++] = x % 10, x /= 10; } while (x);
while (top) putchar(sta[--top] + 48);
}

int pk(int x, int y) {
if (x == y) return 1;
if (x == y + 1 || x == y - 2) return 2;
return 0;
}

int main() {
n = read<int>();
FOR(i, 1, n) a[i] = read<int>();
FOR(i, 1, n - 1) b[i] = read<int>();
FOR(i, 1, n) c[i] = read<int>();
memset(dp, -0x3f, sizeof(dp));
FOR(i, 0, 2) dp[i][0] = pk(i, c[1]) * a[1];
FOR(i, 2, n)
for (int j = i - 1; j >= 0; --j) FOR(k, 0, 2) {
int s = pk(k, c[i]) * a[i];
dp[k][j] += s; // 默认不换
if (j > 0) // 防止越界
FOR(l, 0, 2) // 换,换成 l
dp[k][j] = max(dp[k][j], dp[l][j - 1] + s - b[j]);
}
FOR(i, 0, n - 1)
FOR(j, 0, 2) ans = max(ans, dp[j][i]);
log("%d", ans);
return 0;
}
  • 标题: P10111 [GESP202312 七级] 纸牌游戏 题解
  • 作者: Leo2011
  • 创建于 : 2024-03-13 22:21:38
  • 更新于 : 2024-08-29 11:16:08
  • 链接: https://leo2011.eu.org/2024/03/13/p10111-gesp202312-qi-ji-zhi-pai-you-xi-ti-jie/
  • 版权声明: 本文章采用 CC BY-NC-SA 4.0 进行许可。
评论
目录
P10111 [GESP202312 七级] 纸牌游戏 题解